%{
#undef yywrap
#ifdef DEBUG
int myputc(int c) {putc(c,stderr);return c;}
/*#undef input
#define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):myputc(getc(yyin)))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
*/
#endif
%}


L [a-zA-Z]
C [0-9]

%%
"("	                   {return PAR_OP;}
")"	                   {return PAR_CL;}
"{"	                   {return BRA_OP;}
"}"	                   {return BRA_CL;}
"["	                   {return SBR_OP;}
"]"	                   {return SBR_CL;}
","	                   {return COMMA;}
";"	                   {return SEMCO;}
"->"	                   {return ARROW;}
"|"                        {return PIPE;}
"="                        {return ASSIGN;}
":="	                   {return AFFECT;}
"=="	                   {return EQUAL;}
"!="	                   {return NEQUA;}
"<>"	                   {return NEQUA;}
">"                        {return GT;}
"<"                        {return LT;}
">="                       {return GTOEQ;}
"<="                       {return LTOEQ;}
"#"	                   {return SHARP;}
"^"	                   {return CIRCU;}
"\_"                        {return UNDER;}
"*"	                   {return STAR;}
"-"	                   {return MINUS;}
"+"	                   {return PLUS;}
"/"	                   {return DIV;}

"map"	                   {return MAP;}
"let"                      {return LET;}
"true"                     {yylval.pVal=bvBool(1);
                            return TOK_TRUE;}
"false"                    {yylval.pVal=bvBool(0);
                            return TOK_FALSE;}
"if"	                   {return IF ;}
"then"	                   {return THEN;}
"else"	                   {return ELSE;}
"end"	                   {return ENDIF;}
"endif"	                   {return ENDIF;}
"null"                     {return NULL_ACTION;}
"include"                  {return INCLUDE;}

{L}([\_]|{L}|{C})*         {yylval.pStr=keepIdent(yytext);
                            return IDENT;}
(\"[^\"\n]*\"|\'[^\'\n]*\') {yytext[yyleng-1]='\0';
                            yylval.pStr=UStrDup(yytext+1);
                            return STRING;}
(0)|([1-9]({C}*))          {yylval.pVal=bvInt(yytext);
                            return NUMBER;}
((0)|([1-9]({C}*)))(\.({C}*))((([ \t]*)[eE]([ \t]*)([+-]?)((0)|([1-9]({C}*))))?)			   {yylval.pVal=bvFloat(yytext);
                            return NUMBER;}
[ \t]+                      ; 
\n                          {curLgn++;}
"--".*$                     ;
"//".*$                     ;
"/*"[^*]*"*"(([^/*][^*]*)?"*")*"/"  ;
.                          {char tmp[MAX_CHAR_TMP];
                            sprintf(tmp,"%s: '%c'",ER_LEX_BADCAR,yytext[0]);
                            parseError(tmp);
                           }



