.de EX		\"Begin example
.ne 5
.if n .sp 1
.if t .sp .5
.nf
.in +.5i
..
.de EE
.fi
.in -.5i
.if n .sp 1
.if t .sp .5
..
.TH AGAT 1 "Release 1.2" 
.SH NAME
agat - Another Graphic Animation Tool
.SH SYNTAX
\fBagat \fP [\fIoptions\fP]
.SH DESCRIPTION
.I Agat
is a new system for algorithm animation. \fIAgat\fP differs from other
such systems by its client-server architecture and the use of specialized
programming language to decribe the animation itself, independently of the
animated program.

When you click or you press a key in a window, you can activate commands
(see COMMANDS section).
.SH OPTIONS
There are basically three ways to use an animation :
   - to run the user program with an animation
   - to replay a previously recorded animation
   - to run the user program with no animation but recording the emitted 
values.

Here are the possible corresponding options:

\fBagat\fP [-\fBf\fP \fIagat_file\fP] [-\fBw\fP] [-\fBd\fP \fIdump_file\fP] [-\fBI\fP \fIdir\fP] \fIcmd arg1...argn\fP
.IP 
\fIcmd\fP is executed (with \fIarg1...argn\fP as arguments), and animation 
described by \fIagat_file\fP is performed. The emitted values are 
recorded in \fIdump_file\fP. Several -\fBI\fP can be given 
(specifying a search path). Warning messages are not printed 
if -\fBw\fP flag is present.
.PP
\fBagat\fP -\fBf\fP \fIagat_file\fP [-\fBw\fP] -\fBr\fP \fIdump_file\fP [-\fBI\fP \fIdir\fP] [-\fBs\fP \fIspeed\fP] [-\fBm\fP]
.IP
An animation described by \fIagat_file\fP is performed from the data found in
\fIdump_file\fP. The animation is played at speed \fIspeed\fP. This should be a
positive integer, specifying a percentage of "real-time". So, 50 means
"run at half speed" and 200 "run at double speed". If the -\fBm\fP argument
is present, the animation is replayed as fast as possible. Warning messages
are not printed if the -\fBwfP flag is present.
.PP
\fBagat\fP -\fBd\fP \fIdump_file\fP \fIcmd arg1...argn\fP
.IP
\fIcmd\fP is run with arguments \fIarg1...argn\fP. The emitted values are
recorded in \fIdump_file\fP. No animation is performed.
.PP
.I Agat
accepts several specific options (see RESOURCES section below).
.SH COMMANDS
The \fBkey\fP commands:
.IP \fBb,B\fP 10
To have a \fIbig\fP window.
.IP \fBk,K\fP 10
Kill a zoom window.
.IP \fBn,N\fP 10
To have a \fInormal\fP window.
.IP \fBp,P\fP 10
Create a PostScript file in the current directory. The name of the created 
file is the name of the window in which you press key.
.IP \fBq,Q\fP 10
Quits \fIAgat\fP.
.IP \fBr,R\fP 10
Force to refresh a window. (Specialy for zoom windows)
.IP \fBs,S\fP 10
Stop the animation. Press any key to restart.
.IP \fBt,T\fP 10
To have a \fItiny\fP window.
.PP
The \fBmouse\fP commands:
.IP \fBButton1\fP 10
Display the coordinate of the clicked point. Stopped when button released.
.IP \fBButton2\fP 10
Move the view. Only for 3D operators.
.IP \fBButton3\fP 10
It's the zoom function. When you click on this button, you can select the
area where you want to zoom. Release the button to activate the zoom. You can
zoom in a zoom window. But there is no automatic refresh in a zoom window. To
have a refresh, use the \fBr\fP function.
.SH RESOURCES
\fIAgat\fP has the following application specific resources:
.TP 8
.B background  (\fPClass\fB Background)
Sets the background color of a window.
.TP 8
.B color\fIxx\fP (\fPClass\fB Color\fIxx\fP)
Sets the color number \fIxx\fP for drawing.
.TP 8
.B font  (\fPClass\fB Font)
Sets the font to draw the labels and axes.
.TP 8
.B foreground  (\fPClass\fB Foreground)
Sets the color of the text on the axes.
.TP 8
.B organized  (\fPClass\fB Organized)
Opens the windows with a "beautiful" organization.
.TP 8
.B origx (\fPClass\fB Origx)
Specifies the place of the first window for the X coordinate.
Just use when organized is enable.
.TP 8
.B origy  (\fPClass\fB Origy)
Specifies the place of the first window for the Y coordinate.
Just use when organized is enable.
.TP 8
.B pdx (\fPClass\fB Pdx)
Specifies the space between two windows for the X coordinate.
Just use when organized is enable.
.TP 8
.B pdy  (\fPClass\fB Pdy)
Specifies the space between two windows for the Y coordinate.
Just use when organized is enable.
.TP 8
.B xm (\fPClass\fB Xm)
Specifies the margin in the window for the X coordinate.
.TP 8
.B xsz (\fPClass\fB Xsz)
Specifies the size of the window for the X coordinate.
.TP 8
.B ym (\fPClass\fB Ym)
Specifies the margin in the window for the X coordinate.
.TP 8
.B ysz (\fPClass\fB Ysz)
Specifies the size of the window for the Y coordinate.
.TP 8
.B bigx (\fPClass\fB Bigx)
Specifies the size of a \fIbig\fP window for the X coordinate.
.TP 8
.B bigy (\fPClass\fB Bigy)
Specifies the size of a \fIbig\fP window for the Y coordinate.
.TP 8
.B tinyx (\fPClass\fB Tinyx)
Specifies the size of a \fItiny\fP window for the X coordinate.
.TP 8
.B tinyy (\fPClass\fB Tinyy)
Specifies the size of a \fItiny\fP window for the Y coordinate.
.PP

You can specifie resources for:
.EX 0
   - all the application \t
	\fBagat*\fP<resource>:  <val>
   - a class of graphic operator
	\fBagat.\fP<op_name>\fB*\fP<resource>:  <val>
   - a specified window
	\fBagat.\fP<op_name>\fB.\fP<window_name>\fB.\fP<resource>:  <val>
.EE
For example (the default ressources):
.EX 0
agat.organized:      True
agat.origx:          15
agat.origy:          15
agat.pdx:            10
agat.pdy:            10
agat*background:     White
agat*foreground:     Black
agat*xsz:            300
agat*ysz:            300
agat*bigx:           600
agat*bigy:           600
agat*tinyx:          100
agat*tinyy:          100
agat*xm:             5
agat*ym:             5
agat*markcolor:      Red
agat*font:           \-adobe\-helvetica\-medium\-r\-normal\-*\-18\-180\-75\-75\-p\-98\-iso8859\-1
agat*color0:         Blue
agat*color1:         Magenta
agat*color2:         Red
agat*color3:         Sienna
agat*color4:         DimGray
agat*color5:         Springgreen
agat*color6:         Goldenrod
agat*color7:         Darkorange
agat*color8:         OrangeRed
agat*color9:         Maroon
agat*color10:        Saddlebrown
agat*color11:        Slategrey
agat*color12:        Seagreen
agat*color13:        Navyblue
agat*color14:        Pink
.EE
.SH BUGS
No known bugs. But if you find some, report it to: 
.br
Stephane Lavirotte (slavirot@sophia.inria.fr)
.br
or
.br 
Olivier Arsac (oarsac@sophia.inria.fr)
.SH SEE ALSO
X(1), xrdb(1)
.SH COPYRIGHT
Copyright 1994, INRIA Sophia Antipolis, France. 
.SH AUTHORS
Stephane Dalmas (dalmas@sophia.inria.fr) 
.br
Olivier Arsac (oarsac@sophia.inria.fr)
.br
Marc Geatano (gaetano@sophia.inria.fr)
